﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;

namespace XamGridHierarchicalDT
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        DataSet set;

        public MainWindow()
        {
            InitializeComponent();
            set = GenerateData();

            xamGrid1.ItemsSource = set.Tables[0].DefaultView;
        }

        private DataSet GenerateData()
        {
            var data = new DataSet("SimpleData");
            data.EnforceConstraints = false;

            DataTable parent = new DataTable("Parent");

            parent.Columns.Add("ID", typeof(int));
            parent.Columns.Add("Name", typeof(string));

            parent.PrimaryKey = new[] { parent.Columns[0] };

            DataTable children = new DataTable("Children");

            children.Columns.Add("ID", typeof(int));
            children.Columns.Add("Child", typeof(string));
            children.Columns.Add("Age", typeof(int));
            children.Columns.Add("Parent_ID", typeof(int));

            children.PrimaryKey = new[] { children.Columns[0] };

            data.Tables.Add(parent);
            data.Tables.Add(children);


            data.Relations.Add("Parent_Child", parent.Columns[0], children.Columns[3], false);

            for (int i = 1; i < 4; i++)
            {

                data.Tables["Parent"].Rows.Add(new object[] { i, "Parent" + i });
                for (int j = 0; j < 5; j++)
                {
                    data.Tables["Children"].Rows.Add(new object[] { j, "Child" + j + ", Parent" + i, j + i, i });
                }
            }

            data.AcceptChanges();

            return data;
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            set.Tables[0].Rows[0]["Name"] = "New Parent";
            set.Tables[1].Rows[1]["Child"] = "Some New Child Name";
            set.Tables[1].Rows[1]["Parent_ID"] = 2;

            set.AcceptChanges();
        }
    }
}
